import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Bomb extends Actor
{
    private Boolean playerBomb;
    private Boolean rangeUp;
    private int x;
    private int y;
    private int timer;
    private int lowRange = -75;
    private int highRange = 75;
    String explosionHorizontal = "explosionhorizontal.png";
    String explosionVertical = "explosionvertical.png";
    String explosionCentre = "explosioncentre.png";

    public Bomb(Boolean playerBomb, Boolean rangeUp)
    {
        this.playerBomb = playerBomb;
        this.rangeUp = rangeUp;
        if(rangeUp == true)
        {
            lowRange = -125;
            highRange = 125;
        }
    }
    public void act()
    {
        x = getX();
        y = getY();
        explode();
    }
    private void explode()
    {
        if(timer > 90)
        {
            for(int i = getX() + lowRange; i <= getX() + highRange; i = i + 25)
            {
                getWorld().addObject(new Explosion(explosionHorizontal), i, y);
            }
            
            for(int i = getY() + lowRange; i <= getY() + highRange; i = i + 25)
            {
                getWorld().addObject(new Explosion(explosionVertical), x, i);
            } 
            
            getWorld().addObject(new Explosion(explosionCentre), x, y);
            
            if(getWorld() != null)
            {
                getWorld().removeObject(this);
            }
        }
        else if(timer > 30 && timer < 50)
        {
            setImage("Bomb_2.png");
            timer++;
        }
        else if(timer > 75)
        {
            setImage("Bomb_3.png");
            timer++;
        }
        else
        {
            timer++;
        }
    }
}
