import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is the IntroScreen class. It is a image that is overlaid on the Intro world in order to create a logo and nice
 * appeal to the game.
 */
public class IntroScreen extends Actor
{
    private int i;
    private Boolean canFade = false;
    public void act() 
    {
        if(canFade == true) //Checks if the screen can fade into the game
        {
            fade();
        }
    }    

    /**
     * fade() cycles through images of set transparency that give the impression of the instructions fading on the screen
     * Currently does nothing because we have not found a name for the game yet
     */
    private void fade()
    {
        if(i < 10)
        {
            setImage("IntroScreen" + i + ".png"); //Sets the intro screen based on the current fade amount
            i++;
        }
        else
        {
            Level1 l = new Level1(1); //Changes the world when fade is done
            Greenfoot.setWorld(l);
        }
    }

    public void setFade()
    {
        canFade = true;
    }
}
