import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Level2 extends World
{
    private int i;
    private int x;
    private int y;
    
    /**
     * This is the second level of the game. It is pretty much identical to the first level; however the world layout is a
     * bit different.
     */
    public Level2(int numberOfHumans, int score)
    {    
        // Create a new world with 800x600 cells with a cell size of 1x1 pixels.
        super(800, 600, 1); 
        
        addObject(new Sidebar(2, numberOfHumans, score), 700, 300); //Instantiates the sidebar on the edge of the world
        addObject(new Button("Exit"), 700, 546);
        setPaintOrder(Walls.class, Explosion.class); //Sets the paint order in the world so that sprites do not look bad
        int level[] = {
        /**
         * This is the array that is used in order to instantiate the world. The array is a single-dimension array. We chose
         * using a single-dimensional array because it was easier to view and create within the class editor as compared to
         * a multi-dimensional array.
         * 
         * Each number in the array represents an item in the world as follows:
         * 
         * 1's are unbreakable blocks
         * 6's are randomly placed breakable blocks
         * 0's are nothing, these spots allow the player/enemy to place their first bomb without killing themselves
         * 2's, 3's, 4's and 5's are all spawn points
             2's are for the player
             3's are for enemy 1
             4's are for enemy 2
             5's are for enemy 3
         */
        
          //1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, //1
            1, 2, 0, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 0, 5, 1, //2
            1, 0, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 0, 1, //3
            1, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 1, //4
            1, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 1, //5
            1, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 1, //6
            1, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 1, //7
            1, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 1, //8
            1, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 1, //9
            1, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 1, //10
            1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, //11
            1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, //11
            1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, //13
            1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, //14
            1, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 1, //15
            1, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 1, //16
            1, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 1, //17
            1, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 1, //18
            1, 6, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 6, 1, //19
            1, 6, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 6, 1, //20
            1, 6, 6, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 6, 6, 1, //21
            1, 0, 1, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 1, 0, 1, //22
            1, 3, 0, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 0, 4, 1, //23
            1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};//24
        
        /**
         * Through the use of this array, we can use two for loops to place everything in the world. The first for-loop 
         * cycles through the x-coordinates and calls the next for-loop. The next for-loop cycles through y-coordinates.
         * A switch(level[i]) statement is used. This gets the current position in the array, and parses it through a
         * casewhere statement. In the event that the current digit is equal to 0, we do nothing; these blocks are reserved
         * for the spawn points. In the event that the current digit is equal to 1, an unbreakable wall is placed down. In
         * the event that the current digit is 2, the player is put down. For 3, 4 and 5, a certain enemy is palced down.
         * In the event that the current digit is 6, Greenfoot generates a random number, and there is a 50% chance that
         * an unbreakable wall will be created. However, if there is a different digit in the array, or something that we
         * are not expecting, the default: statement will print out an error. The break; statement skips the rest of the
         * switch() and continues down to i++;. This code continues on until all 576 blocks have been placed down.
         */
        
        int randomKey = 0 + Greenfoot.getRandomNumber(125);
        int randomDoor = 0 + Greenfoot.getRandomNumber(125);
        int randomSpeedUp = 0 + Greenfoot.getRandomNumber(125);
        int randomRangeUp = 0 + Greenfoot.getRandomNumber(125);
        int wallCount = 0;
            
        for(x=0; x<24; x++)
        {
            for(y=0; y<24; y++)
            {
                switch(level[i])
                {
                    case 0: 
                        break;
                    case 1: 
                        addObject(new Walls(true, "Wall_UnBr.png"), x*25+12, y*25+12); 
                        break;
                    case 2: 
                        addObject(new Player1(), x*25+12, y*25+12); 
                        break;
                    case 3: 
                        if(numberOfHumans > 1)
                        {
                            addObject(new Player2(), x*25+12, y*25+12);
                        }
                        else
                        {
                            if(numberOfHumans == 1)
                            {
                                addObject(new Enemies(1), x*25+12, y*25+12);
                            }
                        }
                        break;
                    case 4: 
                        if(numberOfHumans > 2)
                        {
                            addObject(new Player3(), x*25+12, y*25+12);
                        }
                        else
                        {
                            if(numberOfHumans == 1)
                            {
                                addObject(new Enemies(2), x*25+12, y*25+12);
                            }
                        }
                        break;
                    case 5: 
                        if(numberOfHumans > 3)
                        {
                            addObject(new Player3(), x*25+12, y*25+12);
                        }
                        else
                        {
                            if(numberOfHumans == 1)
                            {
                                addObject(new Enemies(3), x*25+12, y*25+12);
                            }
                        }
                        break;
                    case 6:
                        if(Greenfoot.getRandomNumber(101) > 50)
                        {
                            if(wallCount == randomKey)
                            {
                                addObject(new Key(), x*25+12, y*25+12);
                            }
                            if(wallCount == randomDoor)
                            {
                                addObject(new Door(), x*25+12, y*25+12);
                            }
                            if(wallCount == randomRangeUp)
                            {
                                addObject(new RangeUp(), x*25+12, y*25+12);
                            }
                            if(wallCount == randomSpeedUp)
                            {
                                addObject(new SpeedUp(), x*25+12, y*25+12);
                            }
                            addObject(new Walls(false, "Wall_Br.png"), x*25+12, y*25+12);
                            wallCount++;
                        }
                        break;
                    default:
                        System.out.println("Invalid integer in the worldgen array; should only be 0-6");
                        break;
                }
                i++;
            }
        } 
    }
}
