import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Player1 extends Actor
{
    private int moveTimer = 0;
    private int x;
    private int y;
    private Boolean isRangeUp = false;
    private Boolean isSpeedUp = false;
    private int score;
    private int speed = 12;
    int timer = 0;
    int iR = 0;
    int iL = 0;
    int iU = 0;
    int iD = 0;
    int i = 0;
    int i2 = 0;
    int i3 = 18;
    int imgNum = 1;
    boolean hit = false;
    boolean gotKey = false;
    
    /**
     * This is the player1 class. It is the class for the player1 in the game. As the player1 wants to move left and right, the objects move accordingly
     */
    public void act() 
    {
        checkForMoving("W", "D", "S", "A", "Left1.png", "Left2.png", "Right1.png", "Right2.png", "Up1.png", "Up2.png", "OrangePl2.png");
        placeABomb("shift");
        checkForKey();
        checkForPowerups();
        death();
    }
    /**
     * This is the checkForMoving method. It checks whether if the user wishes to move the character by checking if the WASD keys are triggered/activated.
     * If they are, then we increase or decrease our x and y values accordingly. A move timer is used to get rid of the illusion of "smooth movement"
     * and to try to replicate the original movement that is seen in the bomberman games.
     */
    public void checkForMoving(String up, String right, String down, String left, String left1, String left2, String right1, String right2, String up1, String up2, String regular)
    {
        x = getX(); //returns the current x coordinate
        y = getY(); //returns the current y coordinate
        if(moveTimer >= speed && hit == false) //creates a movement timer which checks whether the player1 can move
        {           
            if(Greenfoot.isKeyDown(left) && !Greenfoot.isKeyDown(down) && !Greenfoot.isKeyDown(up))  //checks if the left key is down
            {
                movementAndImages(left1, left2);
                if (getX() -25 >= 0 && getOneObjectAtOffset(-25,0, Walls.class) == null )
                {
                    x = x - 25; //increases 25 to the x coordinate
                    moveTimer = moveTimer + 1; //adds one to the move timer
                }
            }
            if(Greenfoot.isKeyDown(right) && !Greenfoot.isKeyDown(down) && !Greenfoot.isKeyDown(up))//checks if the right key is down
            {
                movementAndImages(right1, right2);
                if (getX() +25 <= 699 && getOneObjectAtOffset(25,0, Walls.class) == null ) 
                {
                    x = x + 25; //increases 25 to the x coordinate
                    moveTimer = moveTimer + 1; //adds one to the move timer
                }
            }
            if(Greenfoot.isKeyDown(up) && !Greenfoot.isKeyDown(right) && !Greenfoot.isKeyDown(left))  //checks if the up key is down
            {
                movementAndImages(up1, up2);
                if( getY() +25 >= 0 && getOneObjectAtOffset(0,-25, Walls.class) == null )
                {
                    y = y - 25;
                    moveTimer = moveTimer + 1; //adds one to the move timer
                }
            }
            if(Greenfoot.isKeyDown(down) && !Greenfoot.isKeyDown(right) && !Greenfoot.isKeyDown(left)) //checks if the s key is down
            {
                movementAndImages(regular, regular);
                if( getY() -25 <= 599 && getOneObjectAtOffset(0, +25, Walls.class) == null )
                {
                    y = y + 25;
                    moveTimer = moveTimer + 1; //adds one to the move timer
                }
            }
            if(!Greenfoot.isKeyDown(up) && !Greenfoot.isKeyDown(down) && !Greenfoot.isKeyDown(left) && !Greenfoot.isKeyDown(right)) //Checks if we are not moving
            {
                setImage(regular);
                moveTimer = moveTimer + 1; //adds one to the move timer
            }
            setLocation(x,y); //sets the new location
            moveTimer = 0;
        }
        else //if the move timer does not let us move, increment it
        {
            moveTimer = moveTimer + 1; //adds one to the move timer
        }
    }

    /**
     * This method allows for the seamless change in animation images. Two images are inputted through parameters
     */
    private void movementAndImages(String img1, String img2)
    {
        if (i == 1)
        {
            setImage(img1);
            moveTimer = 0; //resets the move timer
            i = 0;
        }
        else if(i == 0)
        {
            setImage(img2);
            i = 1;
        }
    }

    /**
     * This is the checkForBomb method. It checks whether the user is pressing the spacebar, and if they are, it spawns a bomb at the current location
     * of the character. A timer only allows for a few bombs to be placed down at a time, however this timer can be changed with powerups.
     */
    public void placeABomb(String bombKey)
    {
        if(Greenfoot.isKeyDown(bombKey) && timer == 0 && Greenfoot.isKeyDown(bombKey) && timer == 0) //checks if the spacebar key is down
        {
            getWorld().addObject(new Bomb(true, isRangeUp), x, y); //adds a new bomb into the world with given powerups, as stated within the parameters of the bomb
            timer = 150;
            for(Object o : getWorld().getObjects(Counter.class)) //gets the counter class in the world and increases it
            {
                Counter c = (Counter) o;
                c.add(15);
            }
        }
        else if(timer > 0)
        {
            timer = timer-1;
        }
    }
    
    /**
     * Checks if we are fulfilling the needs for going to the next level, if we are, then we go to the next level.
     */
    public void checkForKey()
    {
        if(isTouching(Key.class))
        {
            removeTouching(Key.class);
            gotKey = true;
        }
        if(isTouching(Door.class) && gotKey == true)
        {
            for(Object o : getWorld().getObjects(Sidebar.class))
            {
                Sidebar s = (Sidebar) o;
                s.advanceLevel();
            }
        }
    }
    
    /**
     * Checks if we have powerups, if we do, then we use them.
     */
    public void checkForPowerups()
    {
        if(isTouching(RangeUp.class))
        {
            isRangeUp = true;
            removeTouching(RangeUp.class);
            for(Object o : getWorld().getObjects(Sidebar.class))
            {
                Sidebar s = (Sidebar) o;
                s.setPowerups(isRangeUp, isSpeedUp);
            }
        }
        if(isTouching(SpeedUp.class))
        {
            speed = 6;
            isSpeedUp = true;
            removeTouching(SpeedUp.class);
            for(Object o : getWorld().getObjects(Sidebar.class))
            {
                Sidebar s = (Sidebar) o;
                s.setPowerups(isRangeUp, isSpeedUp);
            }
        }
    }
    
    /**
     * Checks if we are touching the explosion class. If we are, the we get rid of the player.
     */
    public void death()
    {
        if (isTouching(Explosion.class) && getWorld() != null)
        {
            for(Object o : getWorld().getObjects(Sidebar.class))
            {
                Sidebar s = (Sidebar) o;
                s.deadPlayer();
            }
            getWorld().removeObject(this);
        }
    }
}
