import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color; //Allows for GreenfootImage to work properly with java colours

/**
 * General purpose string displaying class
 * Class is completly abstract, allows for any type of text, size of text, and colour of text to be displayed. All of
 * the attributes are set through the parameters
 */

public class TextDisplayer extends Actor
{
    /**
     * This method is called every time the TextDisplayer class is instantiated. It requires four parameters, allowing
     * for the attributes to be specified upon instantiation. The first parameter is the text that is going to be
     * displayed. The second parameter is the size of the text, generally around 20 or so. The third parameter is the
     * foreground colour, specified as a java.awt.Color data type (i.e., being either Color.WHITE, Color.BLACK, etc.)
     * The fourth data type is the background colour for the text, using the same data type as the foreground parameter.
     * The value of null can be passed through as the third or fourth parameter to display a transparent colour.
     */
    public TextDisplayer(String text, int size, java.awt.Color foregroundColor, java.awt.Color backgroundColor)
    {
        GreenfootImage gi = new GreenfootImage(text, size, foregroundColor, backgroundColor); //Constructor for the GreenfootImage with the above parameters
        setImage(gi); //Sets the image of the class to the above image specified
    }
}
