import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is the walls class. It is responsible for all the walls in the game, including the barrier walls and breakable walls.
 */
public class Walls extends Actor
{
    boolean type;
    public void act() 
    {
        checkForExplosion();
    }    

    public Walls(boolean type, String image)
    {
        this.type = type;
        setImage(image);
    }

    /**
     * Checks if there is an explosion on the current block. If there is, then we check what type of wall it is. If it is breakable,
     * we delete it. If it is not, we do not delete it.
     */
    private void checkForExplosion()
    {
        if(isTouching(Explosion.class) && type == false) //Checks if we are touching the explosion
        {
            if(getWorld() != null)
            {
                getWorld().removeObject(this);
            }
        }
        else if(isTouching(Explosion.class) && type == true)//Checks if we are touching the explosion
        {
            removeTouching(Explosion.class);
        }
    }
}
